Wt: Wt::WGoogleMap Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Protected Member Functions | List of all members
Wt::WGoogleMap Class Reference

A widget that displays a google map. More...

`#include <Wt/WGoogleMap.h>`

Inheritance diagram for Wt::WGoogleMap:
[legend]

## Classes
class | Coordinate
| A geographical coordinate (latitude/longitude) More...

## Public Types
typedef GoogleMapsVersion | Version
| Typedef for enum Wt::GoogleMapsVersion.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.

## Public Member Functions
| WGoogleMap (GoogleMapsVersion version=GoogleMapsVersion::v3)
| Creates a map widget with a version.
virtual | ~WGoogleMap ()
| Destructor.
void | addMarker (const Coordinate &pos)
| Adds a marker overlay to the map.
void | addPolyline (const std::vector< Coordinate > &points, const WColor &color=WColor(StandardColor::Red), int width=2, double opacity=1.0)
| Adds a polyline overlay to the map.
void | addCircle (const Coordinate &center, double radius, const WColor &strokeColor, int strokeWidth, const WColor &fillColor=WColor())
| Adds a circle to the map.
void | addIconMarker (const Coordinate &pos, const std::string &iconURL)
| Adds a icon marker overlay to the map.
void | clearOverlays ()
| Removes all overlays from the map.
void | openInfoWindow (const Coordinate &pos, const Wt::WString &myHtml)
| Opens a text bubble with html text at a specific location.
void | setCenter (const Coordinate &center)
| Sets the map view to the given center.
void | setCenter (const Coordinate &center, int zoom)
| Sets the map view to the given center and zoom level.
void | panTo (const Coordinate &center)
| Changes the center point of the map to the given point.
void | zoomWindow (const std::pair< Coordinate, Coordinate > &bbox)
| Zooms the map to a region defined by a bounding box.
void | zoomWindow (const Coordinate &topLeft, const Coordinate &bottomRight)
| Zooms the map to a region defined by a bounding box.
void | setZoom (int level)
| Sets the zoom level to the given new value.
void | zoomIn ()
| Increments zoom level by one.
void | zoomOut ()
| Decrements zoom level by one.
void | savePosition ()
| Stores the current map position and zoom level.
void | returnToSavedPosition ()
| Restores the map view that was saved by savePosition().
void | enableDragging ()
| Enables the dragging of the map (enabled by default).
void | disableDragging ()
| Disables the dragging of the map.
void | enableDoubleClickZoom ()
| Enables double click to zoom in and out (enabled by default).
void | disableDoubleClickZoom ()
| Disables double click to zoom in and out.
void | enableGoogleBar ()
| Enables the GoogleBar, an integrated search control, on the map.
void | disableGoogleBar ()
| Disables the GoogleBar integrated search control.
void | enableScrollWheelZoom ()
| Enables zooming using a mouse's scroll wheel.
void | disableScrollWheelZoom ()
| Disables zooming using a mouse's scroll wheel.
void | setMapTypeControl (MapTypeControl type)
| Sets the map type control.
JSignal< Coordinate > & | clicked ()
| The click event.
JSignal< Coordinate > & | doubleClicked ()
| The double click event.
JSignal< Coordinate > & | mouseMoved ()
| This event is fired when the user moves the mouse inside the map.
GoogleMapsVersion | apiVersion ()
| Return the used Google Maps API version.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
virtual void | doGmJavaScript (const std::string &jscode)
| Execute a piece of JavaScript that manipulates the map.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that displays a google map.

This widget uses the online Google Maps server to display a map. It exposes a part of the google maps API.

This widget supports both version 2 and version 3 of the Google Maps API. The version 2 API is used by default, to enable the version 3 API, use the constructor's version argument.

To use the map on a public server you will need to obtain a key. The widget will look for this key as the configuration property `"google_api_key"`. If this configuration property has not been set, it will use a key that is suitable for localhost.

### CSS

Styling through CSS is not applicable.

Contributed by: Richard Ulrich.

## Member Function Documentation

## ◆ addCircle()

void Wt::WGoogleMap::addCircle | ( | const Coordinate & | center,
|  | double | radius,
|  | const WColor & | strokeColor,
|  | int | strokeWidth,
|  | const WColor & | fillColor = WColor() )

Adds a circle to the map.

The stroke and fill opacity can be configured respectively in the strokeColor and fillColor. This feature is only supported by the Google Maps API version 3.

## ◆ addPolyline()

void Wt::WGoogleMap::addPolyline | ( | const std::vector< Coordinate > & | points,
|  | const WColor & | color = WColor(StandardColor::Red),
|  | int | width = 2,
|  | double | opacity = 1.0 )

Adds a polyline overlay to the map.

Specify a value between 0.0 and 1.0 for the opacity or set the alpha value in the color.

## ◆ clicked()

JSignal< Coordinate > & Wt::WGoogleMap::clicked | ( |  | ) |

The click event.

This event is fired when the user clicks on the map with the mouse.

## ◆ disableGoogleBar()

void Wt::WGoogleMap::disableGoogleBar | ( |  | ) |

Disables the GoogleBar integrated search control.

When disabled, the default Powered by Google logo occupies the position formerly containing this control. Note that this control is already disabled by default.

Note
  This functionality is no longer available in the Google Maps API v3.

## ◆ disableScrollWheelZoom()

void Wt::WGoogleMap::disableScrollWheelZoom | ( |  | ) |

Disables zooming using a mouse's scroll wheel.

Scroll wheel zoom is disabled by default.

## ◆ doGmJavaScript()

virtual void Wt::WGoogleMap::doGmJavaScript | ( | const std::string & | jscode | ) |
| protectedvirtual

Execute a piece of JavaScript that manipulates the map.

This is like doJavaScript() but delays the javascript until the map has been loaded.

## ◆ doubleClicked()

JSignal< Coordinate > & Wt::WGoogleMap::doubleClicked | ( |  | ) |

The double click event.

This event is fired when a double click is done on the map.

## ◆ enableGoogleBar()

void Wt::WGoogleMap::enableGoogleBar | ( |  | ) |

Enables the GoogleBar, an integrated search control, on the map.

When enabled, this control takes the place of the default Powered By Google logo.

This control is initially disabled.

Note
  This functionality is no longer available in the Google Maps API v3.

## ◆ enableScrollWheelZoom()

void Wt::WGoogleMap::enableScrollWheelZoom | ( |  | ) |

Enables zooming using a mouse's scroll wheel.

Scroll wheel zoom is disabled by default.

## ◆ panTo()

void Wt::WGoogleMap::panTo | ( | const Coordinate & | center | ) |

Changes the center point of the map to the given point.

If the point is already visible in the current map view, change the center in a smooth animation.

## ◆ render()

virtual void Wt::WGoogleMap::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

## ◆ savePosition()

void Wt::WGoogleMap::savePosition | ( |  | ) |

Stores the current map position and zoom level.

You can later restore this position using returnToSavedPosition().

## ◆ setMapTypeControl()

void Wt::WGoogleMap::setMapTypeControl | ( | MapTypeControl | type | ) |

Sets the map type control.

The control allows selecting and switching between supported map types via buttons.